diff --git a/tests/Makefile b/tests/Makefile
index ab83ae855d..dd84024c61 100644
--- a/tests/Makefile
+++ b/tests/Makefile
@@ -135,6 +135,7 @@ include $(SRC_PATH)/tests/fate/flac.mak
 include $(SRC_PATH)/tests/fate/flvenc.mak
 include $(SRC_PATH)/tests/fate/gapless.mak
 include $(SRC_PATH)/tests/fate/gif.mak
+include $(SRC_PATH)/tests/fate/gdv.mak
 include $(SRC_PATH)/tests/fate/h264.mak
 include $(SRC_PATH)/tests/fate/hevc.mak
 include $(SRC_PATH)/tests/fate/image.mak
diff --git a/tests/fate/gdv.mak b/tests/fate/gdv.mak
new file mode 100644
index 0000000000..c13ff1b306
--- /dev/null
+++ b/tests/fate/gdv.mak
@@ -0,0 +1,8 @@
+FATE_GDV += fate-gdv-sound
+fate-gdv-sound: CMD = framecrc -i $(TARGET_SAMPLES)/gdv/chptr1.gdv
+
+FATE_GDV += fate-gdv-nosound
+fate-gdv-nosound: CMD = framecrc -i $(TARGET_SAMPLES)/gdv/ace.gdv
+
+FATE_SAMPLES_AVCONV-$(call DEMDEC, GDV, GREMLIN_DPCM) += $(FATE_GDV)
+fate-gdv: $(FATE_GDV)
diff --git a/tests/ref/fate/gdv-nosound b/tests/ref/fate/gdv-nosound
new file mode 100644
index 0000000000..0711b21955
--- /dev/null
+++ b/tests/ref/fate/gdv-nosound
@@ -0,0 +1,26 @@
+#tb 0: 1/12
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 170x140
+#sar 0: 0/1
+0,          0,          0,        1,    24824, 0xf1ea7772
+0,          1,          1,        1,    24824, 0x71c96f46
+0,          2,          2,        1,    24824, 0x19d770b6
+0,          3,          3,        1,    24824, 0x52d367da
+0,          4,          4,        1,    24824, 0x27456475
+0,          5,          5,        1,    24824, 0xf3a736d0
+0,          6,          6,        1,    24824, 0x37eb8b85
+0,          7,          7,        1,    24824, 0xb67b0189
+0,          8,          8,        1,    24824, 0x2d96b41b
+0,          9,          9,        1,    24824, 0x13e786b2
+0,         10,         10,        1,    24824, 0xf0013f48
+0,         11,         11,        1,    24824, 0x2a98987f
+0,         12,         12,        1,    24824, 0x639bad98
+0,         13,         13,        1,    24824, 0x16c8b675
+0,         14,         14,        1,    24824, 0x5a5ea733
+0,         15,         15,        1,    24824, 0xb1117e1f
+0,         16,         16,        1,    24824, 0x8e6e160d
+0,         17,         17,        1,    24824, 0x0f1cf460
+0,         18,         18,        1,    24824, 0xe74f6af9
+0,         19,         19,        1,    24824, 0x93782bb9
+0,         20,         20,        1,    24824, 0x64bedff4
diff --git a/tests/ref/fate/gdv-sound b/tests/ref/fate/gdv-sound
new file mode 100644
index 0000000000..d513388654
--- /dev/null
+++ b/tests/ref/fate/gdv-sound
@@ -0,0 +1,181 @@
+#tb 0: 1/12
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 320x280
+#sar 0: 0/1
+#tb 1: 1/21168
+#media_type 1: audio
+#codec_id 1: pcm_s16le
+#sample_rate 1: 21168
+#channel_layout 1: 3
+#channel_layout_name 1: stereo
+0,          0,          0,        1,    90624, 0x30935496
+1,          0,          0,     1764,     7056, 0x1ef9f1a9
+0,          1,          1,        1,    90624, 0x30935496
+1,       1764,       1764,     1764,     7056, 0xd674880b
+0,          2,          2,        1,    90624, 0x30935496
+1,       3528,       3528,     1764,     7056, 0xb1722fdb
+0,          3,          3,        1,    90624, 0x30935496
+1,       5292,       5292,     1764,     7056, 0xd7abd112
+0,          4,          4,        1,    90624, 0x30935496
+1,       7056,       7056,     1764,     7056, 0x5c0ccc2a
+0,          5,          5,        1,    90624, 0x30935496
+1,       8820,       8820,     1764,     7056, 0xef320314
+0,          6,          6,        1,    90624, 0x30935496
+1,      10584,      10584,     1764,     7056, 0x36a2ddca
+0,          7,          7,        1,    90624, 0x847784d8
+1,      12348,      12348,     1764,     7056, 0x48236a4d
+0,          8,          8,        1,    90624, 0xdbbe9835
+1,      14112,      14112,     1764,     7056, 0xf70babf9
+0,          9,          9,        1,    90624, 0xc9caca0f
+1,      15876,      15876,     1764,     7056, 0xcc2ec0a1
+0,         10,         10,        1,    90624, 0x7b03228e
+1,      17640,      17640,     1764,     7056, 0xc83a5e6c
+0,         11,         11,        1,    90624, 0x4e8a7246
+1,      19404,      19404,     1764,     7056, 0x6f9075d8
+0,         12,         12,        1,    90624, 0x8ba5c3cb
+1,      21168,      21168,     1764,     7056, 0xcda9440a
+0,         13,         13,        1,    90624, 0xe5ab48d3
+1,      22932,      22932,     1764,     7056, 0xc88ca419
+0,         14,         14,        1,    90624, 0xe2f5bbd7
+1,      24696,      24696,     1764,     7056, 0x997ec49d
+0,         15,         15,        1,    90624, 0x70f60082
+1,      26460,      26460,     1764,     7056, 0x28f86cf0
+0,         16,         16,        1,    90624, 0x96f3fc88
+1,      28224,      28224,     1764,     7056, 0xa39e9517
+0,         17,         17,        1,    90624, 0x1aaf3476
+1,      29988,      29988,     1764,     7056, 0xfa63159f
+0,         18,         18,        1,    90624, 0x489b6871
+1,      31752,      31752,     1764,     7056, 0x782a2fde
+0,         19,         19,        1,    90624, 0x8dfb84bc
+1,      33516,      33516,     1764,     7056, 0x2cf6d98b
+0,         20,         20,        1,    90624, 0x18c9bc60
+1,      35280,      35280,     1764,     7056, 0xd7c23840
+0,         21,         21,        1,    90624, 0xdc57e3fa
+1,      37044,      37044,     1764,     7056, 0x56cba429
+0,         22,         22,        1,    90624, 0x78d40360
+1,      38808,      38808,     1764,     7056, 0x32ee7de9
+0,         23,         23,        1,    90624, 0x19033e41
+1,      40572,      40572,     1764,     7056, 0x6e3448b0
+0,         24,         24,        1,    90624, 0xf49b4708
+1,      42336,      42336,     1764,     7056, 0x360db3f3
+0,         25,         25,        1,    90624, 0xd4da6f3f
+1,      44100,      44100,     1764,     7056, 0xfa05b166
+0,         26,         26,        1,    90624, 0x9a396fa0
+1,      45864,      45864,     1764,     7056, 0x508d9f61
+0,         27,         27,        1,    90624, 0x90725c61
+1,      47628,      47628,     1764,     7056, 0xbcdb036d
+0,         28,         28,        1,    90624, 0x18e75cac
+1,      49392,      49392,     1764,     7056, 0x5e1efa4f
+0,         29,         29,        1,    90624, 0x367559d9
+1,      51156,      51156,     1764,     7056, 0x3e3409ee
+0,         30,         30,        1,    90624, 0x2b446e45
+1,      52920,      52920,     1764,     7056, 0x77ae945c
+0,         31,         31,        1,    90624, 0x0eab7981
+1,      54684,      54684,     1764,     7056, 0xb17ebc49
+0,         32,         32,        1,    90624, 0xdf1e3627
+1,      56448,      56448,     1764,     7056, 0xbd9db878
+0,         33,         33,        1,    90624, 0x6ef3fd83
+1,      58212,      58212,     1764,     7056, 0x8053cdf5
+0,         34,         34,        1,    90624, 0xad09a3cb
+1,      59976,      59976,     1764,     7056, 0x632cca76
+0,         35,         35,        1,    90624, 0x37677b22
+1,      61740,      61740,     1764,     7056, 0x7121db7d
+0,         36,         36,        1,    90624, 0x16cd86d9
+1,      63504,      63504,     1764,     7056, 0xefc79f49
+0,         37,         37,        1,    90624, 0x13c27ca4
+1,      65268,      65268,     1764,     7056, 0xc7c785d5
+0,         38,         38,        1,    90624, 0x545a79cd
+1,      67032,      67032,     1764,     7056, 0xb402a8b4
+0,         39,         39,        1,    90624, 0xa3068334
+1,      68796,      68796,     1764,     7056, 0x26dc7822
+0,         40,         40,        1,    90624, 0xa5b06a17
+1,      70560,      70560,     1764,     7056, 0x94055d98
+0,         41,         41,        1,    90624, 0xf9b87a0d
+1,      72324,      72324,     1764,     7056, 0x1fbce96a
+0,         42,         42,        1,    90624, 0x57fb84f3
+1,      74088,      74088,     1764,     7056, 0xc14ae760
+0,         43,         43,        1,    90624, 0x4a988bb1
+1,      75852,      75852,     1764,     7056, 0x93ebbd5e
+0,         44,         44,        1,    90624, 0xc641a196
+1,      77616,      77616,     1764,     7056, 0x0806da3f
+0,         45,         45,        1,    90624, 0x93f4ba62
+1,      79380,      79380,     1764,     7056, 0xf1cd68d0
+0,         46,         46,        1,    90624, 0xedacc8e2
+1,      81144,      81144,     1764,     7056, 0x23b30a62
+0,         47,         47,        1,    90624, 0x375e0f99
+1,      82908,      82908,     1764,     7056, 0x088de09c
+0,         48,         48,        1,    90624, 0x17170fd1
+1,      84672,      84672,     1764,     7056, 0x6b60ceb9
+0,         49,         49,        1,    90624, 0x6a0a36f3
+1,      86436,      86436,     1764,     7056, 0x10f81053
+0,         50,         50,        1,    90624, 0x438b4855
+1,      88200,      88200,     1764,     7056, 0x1d497d71
+0,         51,         51,        1,    90624, 0xd8f547df
+1,      89964,      89964,     1764,     7056, 0x0e5cc461
+0,         52,         52,        1,    90624, 0xf3e1edc9
+1,      91728,      91728,     1764,     7056, 0x7d769049
+0,         53,         53,        1,    90624, 0xb46fe689
+1,      93492,      93492,     1764,     7056, 0x81b6885b
+0,         54,         54,        1,    90624, 0x84459e67
+1,      95256,      95256,     1764,     7056, 0x1dc87e5c
+0,         55,         55,        1,    90624, 0x3a7772ec
+1,      97020,      97020,     1764,     7056, 0xbe76b87f
+0,         56,         56,        1,    90624, 0xa7df09e8
+1,      98784,      98784,     1764,     7056, 0xa706f339
+0,         57,         57,        1,    90624, 0x50d4e18f
+1,     100548,     100548,     1764,     7056, 0x46920a19
+0,         58,         58,        1,    90624, 0x8e090613
+1,     102312,     102312,     1764,     7056, 0xec577db4
+0,         59,         59,        1,    90624, 0x07e1bcc4
+1,     104076,     104076,     1764,     7056, 0x6073a4b3
+0,         60,         60,        1,    90624, 0x0a749a0f
+1,     105840,     105840,     1764,     7056, 0x1fd678af
+0,         61,         61,        1,    90624, 0x4137598c
+1,     107604,     107604,     1764,     7056, 0x88bd997f
+0,         62,         62,        1,    90624, 0xde6aeb9d
+1,     109368,     109368,     1764,     7056, 0x0c9aa589
+0,         63,         63,        1,    90624, 0x9b9aacac
+1,     111132,     111132,     1764,     7056, 0xea9df14c
+0,         64,         64,        1,    90624, 0x0c9b1c20
+1,     112896,     112896,     1764,     7056, 0x161ad2b2
+0,         65,         65,        1,    90624, 0x28d3f6ce
+1,     114660,     114660,     1764,     7056, 0xb7aa2f56
+0,         66,         66,        1,    90624, 0x22ed6d7f
+1,     116424,     116424,     1764,     7056, 0xa325c5b6
+0,         67,         67,        1,    90624, 0x038cb935
+1,     118188,     118188,     1764,     7056, 0xd5a3a72d
+0,         68,         68,        1,    90624, 0x5b97c189
+1,     119952,     119952,     1764,     7056, 0x1372f6d8
+0,         69,         69,        1,    90624, 0x3a03c36e
+1,     121716,     121716,     1764,     7056, 0xa6718b63
+0,         70,         70,        1,    90624, 0xde8c6c72
+1,     123480,     123480,     1764,     7056, 0xdac2f05e
+1,     125243,     125243,     1764,     7056, 0xdd82ebdf
+0,         71,         71,        1,    90624, 0x75b6e22a
+1,     127007,     127007,     1764,     7056, 0x1422ae5c
+0,         72,         72,        1,    90624, 0xf5d17cf9
+1,     128771,     128771,     1764,     7056, 0xc2a2f09d
+0,         73,         73,        1,    90624, 0x81631c3e
+1,     130535,     130535,     1764,     7056, 0xac10dcfb
+0,         74,         74,        1,    90624, 0xa5b0555b
+1,     132299,     132299,     1764,     7056, 0xdf3fac88
+0,         75,         75,        1,    90624, 0x400b10ab
+1,     134063,     134063,     1764,     7056, 0x3b880caf
+0,         76,         76,        1,    90624, 0x4bde99e6
+1,     135827,     135827,     1764,     7056, 0x5d67d676
+0,         77,         77,        1,    90624, 0xc3ab4411
+1,     137591,     137591,     1764,     7056, 0x6976e528
+0,         78,         78,        1,    90624, 0x50219680
+1,     139355,     139355,     1764,     7056, 0x4e74fb69
+0,         79,         79,        1,    90624, 0x50219680
+1,     141119,     141119,     1764,     7056, 0x92e4d4ab
+0,         80,         80,        1,    90624, 0x50219680
+1,     142883,     142883,     1764,     7056, 0x839710fc
+0,         81,         81,        1,    90624, 0x50219680
+1,     144647,     144647,     1764,     7056, 0x4d4c96bb
+0,         82,         82,        1,    90624, 0x50219680
+1,     146411,     146411,     1764,     7056, 0x607408be
+0,         83,         83,        1,    90624, 0x50219680
+1,     148175,     148175,     1764,     7056, 0x2c775889
+0,         84,         84,        1,    90624, 0x50219680