diff --git a/tests/Makefile b/tests/Makefile
index e09f30a0fc..d8a1abd04e 100644
--- a/tests/Makefile
+++ b/tests/Makefile
@@ -230,6 +230,7 @@ include $(SRC_PATH)/tests/fate/qt.mak
 include $(SRC_PATH)/tests/fate/qtrle.mak
 include $(SRC_PATH)/tests/fate/real.mak
 include $(SRC_PATH)/tests/fate/screen.mak
+include $(SRC_PATH)/tests/fate/sdr.mak
 include $(SRC_PATH)/tests/fate/segafilm.mak
 include $(SRC_PATH)/tests/fate/segment.mak
 include $(SRC_PATH)/tests/fate/source.mak
diff --git a/tests/fate/sdr.mak b/tests/fate/sdr.mak
new file mode 100644
index 0000000000..a4d9fbba47
--- /dev/null
+++ b/tests/fate/sdr.mak
@@ -0,0 +1,11 @@
+FATE_SDR = fate-sdr-am \
+           fate-sdr-fm \
+
+FATE_SAMPLES_FFMPEG += $(FATE_SDR)
+
+fate-sdr-am: CMD = framecrc -mode all_mode -video_size 400x200 -i $(TARGET_SAMPLES)/sdr/am.sdr -map 0 -filter:a aresample
+fate-sdr-fm: CMD = framecrc -mode all_mode -video_size 400x200 -i $(TARGET_SAMPLES)/sdr/fm.sdr -map 0 -filter:a aresample
+
+FATE_FFMPEG += $(FATE_SDR_FFMPEG-yes)
+
+fate-sdr: $(FATE_SDR) $(FATE_SDR_FFMPEG-yes)
diff --git a/tests/ref/fate/sdr-am b/tests/ref/fate/sdr-am
new file mode 100644
index 0000000000..17f9c25714
--- /dev/null
+++ b/tests/ref/fate/sdr-am
@@ -0,0 +1,55 @@
+#tb 0: 12/125
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 400x200
+#sar 0: 0/1
+#tb 1: 1/16000
+#media_type 1: audio
+#codec_id 1: pcm_s16le
+#sample_rate 1: 16000
+#channel_layout_name 1: stereo
+#tb 2: 1/16000
+#media_type 2: audio
+#codec_id 2: pcm_s16le
+#sample_rate 2: 16000
+#channel_layout_name 2: stereo
+#tb 3: 1/16000
+#media_type 3: audio
+#codec_id 3: pcm_s16le
+#sample_rate 3: 16000
+#channel_layout_name 3: stereo
+#tb 4: 1/16000
+#media_type 4: audio
+#codec_id 4: pcm_s16le
+#sample_rate 4: 16000
+#channel_layout_name 4: stereo
+#tb 5: 1/16000
+#media_type 5: audio
+#codec_id 5: pcm_s16le
+#sample_rate 5: 16000
+#channel_layout_name 5: stereo
+#tb 6: 1/16000
+#media_type 6: audio
+#codec_id 6: pcm_s16le
+#sample_rate 6: 16000
+#channel_layout_name 6: stereo
+0,          0,          0,        1,   320000, 0x816a0964
+0,          1,          1,        1,   320000, 0x140ce2da
+1,       2048,       2048,     1024,     4096, 0x41e3b1dc
+2,       2048,       2048,     1024,     4096, 0x13fff8c1
+3,       2048,       2048,     1024,     4096, 0x71517ac5
+4,       2048,       2048,     1024,     4096, 0x4e5d8739
+5,       2048,       2048,     1024,     4096, 0x4fa3f554
+1,       3072,       3072,     1024,     4096, 0x0c81096b
+2,       3072,       3072,     1024,     4096, 0x1b3c0be0
+3,       3072,       3072,     1024,     4096, 0x483afe54
+4,       3072,       3072,     1024,     4096, 0x76b2f3d0
+5,       3072,       3072,     1024,     4096, 0xd98708c7
+6,       3072,       3072,     1024,     4096, 0x997fd85b
+1,       4096,       4096,     1024,     4096, 0xb1b6e47e
+2,       4096,       4096,     1024,     4096, 0x803a0df9
+3,       4096,       4096,     1024,     4096, 0xfa14198a
+4,       4096,       4096,     1024,     4096, 0xddd40288
+5,       4096,       4096,     1024,     4096, 0x96cd01e5
+6,       4096,       4096,     1024,     4096, 0xf38ce9c6
+0,          3,          3,        1,   320000, 0x73e13a75
diff --git a/tests/ref/fate/sdr-fm b/tests/ref/fate/sdr-fm
new file mode 100644
index 0000000000..e5113f4a08
--- /dev/null
+++ b/tests/ref/fate/sdr-fm
@@ -0,0 +1,25 @@
+#tb 0: 12/187
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 400x200
+#sar 0: 0/1
+#tb 1: 1/64000
+#media_type 1: audio
+#codec_id 1: pcm_s16le
+#sample_rate 1: 64000
+#channel_layout_name 1: stereo
+#tb 2: 1/64000
+#media_type 2: audio
+#codec_id 2: pcm_s16le
+#sample_rate 2: 64000
+#channel_layout_name 2: stereo
+0,          0,          0,        1,   320000, 0xf553af75
+0,          1,          1,        1,   320000, 0xeabc15b3
+1,       8196,       8196,     4096,    16384, 0xc7836d34
+2,       8196,       8196,     4096,    16384, 0xec685101
+1,      12292,      12292,     4096,    16384, 0x8962131e
+2,      12292,      12292,     4096,    16384, 0x5c61360b
+0,          3,          3,        1,   320000, 0x1b178638
+1,      16388,      16388,     4096,    16384, 0xfcb8d5ce
+2,      16388,      16388,     4096,    16384, 0xc9ceb9d6
+0,          4,          4,        1,   320000, 0x49dd90cc