diff --git a/tests/Makefile b/tests/Makefile
index e09f30a0fc..f108a2460b 100644
--- a/tests/Makefile
+++ b/tests/Makefile
@@ -176,6 +176,7 @@ include $(SRC_PATH)/tests/fate/dnxhd.mak
 include $(SRC_PATH)/tests/fate/dpcm.mak
 include $(SRC_PATH)/tests/fate/dvvideo.mak
 include $(SRC_PATH)/tests/fate/ea.mak
+include $(SRC_PATH)/tests/fate/ec.mak
 include $(SRC_PATH)/tests/fate/exif.mak
 include $(SRC_PATH)/tests/fate/enc_external.mak
 # Must be included after lavf-video.mak
diff --git a/tests/fate/ec.mak b/tests/fate/ec.mak
new file mode 100644
index 0000000000..fe46b7f8f8
--- /dev/null
+++ b/tests/fate/ec.mak
@@ -0,0 +1,6 @@
+FATE_EC-$(call ALLYES, ERROR_RESILIENCE H264_PARSER H264_DECODER) += fate-ec-sidedata-h264
+fate-ec-sidedata-h264: SRC = $(TARGET_SAMPLES)/ec/basic.h264
+fate-ec-sidedata-h264: CMD = run ffprobe$(PROGSSUF)$(EXESUF) -export_side_data +error_info -show_entries side_data -print_format default -bitexact -v 0 -i "$(SRC)"
+
+FATE_SAMPLES_FFMPEG+=$(FATE_EC-yes)
+fate-ec: $(FATE_EC-yes)
diff --git a/tests/ref/fate/ec-sidedata-h264 b/tests/ref/fate/ec-sidedata-h264
new file mode 100644
index 0000000000..e00d2fc89c
--- /dev/null
+++ b/tests/ref/fate/ec-sidedata-h264
@@ -0,0 +1,332 @@
+[PACKET]
+[/PACKET]
+[PACKET]
+[/PACKET]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=414720
+error=142336
+ref_ok=0
+ref_error=0
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=414720
+ref_error=142336
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=414720
+ref_error=142336
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=414720
+ref_error=142336
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=414720
+ref_error=142336
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=414720
+ref_error=142336
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=414720
+ref_error=142336
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=414720
+ref_error=142336
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=414720
+ref_error=142336
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=1007360
+ref_error=663808
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=290816
+error=266240
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=1007360
+ref_error=663808
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=301824
+error=255232
+ref_ok=414720
+ref_error=142336
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[PACKET]
+[/PACKET]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[FRAME]
+[SIDE_DATA]
+side_data_type=Error Concealment Information
+ok=0
+error=0
+ref_ok=716544
+ref_error=397568
+[/SIDE_DATA]
+[/FRAME]
+[STREAM]
+[/STREAM]