diff --git a/tests/Makefile b/tests/Makefile
index 9b70145..e073915 100644
--- a/tests/Makefile
+++ b/tests/Makefile
@@ -172,6 +172,7 @@ include $(SRC_PATH)/tests/fate/dca.mak
 include $(SRC_PATH)/tests/fate/demux.mak
 include $(SRC_PATH)/tests/fate/dfa.mak
 include $(SRC_PATH)/tests/fate/dnxhd.mak
+include $(SRC_PATH)/tests/fate/dnxuc.mak
 include $(SRC_PATH)/tests/fate/dpcm.mak
 include $(SRC_PATH)/tests/fate/dvvideo.mak
 include $(SRC_PATH)/tests/fate/ea.mak
diff --git a/tests/fate/dnxuc.mak b/tests/fate/dnxuc.mak
new file mode 100644
index 0000000..80ff0e9
--- /dev/null
+++ b/tests/fate/dnxuc.mak
@@ -0,0 +1,40 @@
+FATE_DNXUC_CB = fate-dnxuc-cb-rgb-8 \
+                fate-dnxuc-cb-rgb-10 \
+                fate-dnxuc-cb-rgb-12 \
+                fate-dnxuc-cb-rgb-half \
+                fate-dnxuc-cb-rgb-float \
+                fate-dnxuc-cb-yuv422-8 \
+                fate-dnxuc-cb-yuv422-10 \
+                fate-dnxuc-cb-yuv422-12
+
+FATE_DNXUC_RAMP =   fate-dnxuc-ramp-rgb-8 \
+                    fate-dnxuc-ramp-rgb-10 \
+                    fate-dnxuc-ramp-rgb-12 \
+                    fate-dnxuc-ramp-rgb-half \
+                    fate-dnxuc-ramp-rgb-float \
+                    fate-dnxuc-ramp-yuv422-8 \
+                    fate-dnxuc-ramp-yuv422-10 \
+                    fate-dnxuc-ramp-yuv422-12
+
+FATE_DNXUC-$(call FRAMECRC, MXF, DNXUC) += $(FATE_DNXUC_CB) $(FATE_DNXUC_RAMP)
+
+FATE_SAMPLES_FFMPEG += $(FATE_DNXUC-yes)
+fate-dnxuc: $(FATE_DNXUC-yes)
+
+fate-dnxuc-cb-rgb-8: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/cb_rgb_8.mxf
+fate-dnxuc-cb-rgb-10: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/cb_rgb_10.mxf
+fate-dnxuc-cb-rgb-12: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/cb_rgb_12.mxf
+fate-dnxuc-cb-rgb-half: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/cb_rgb_half.mxf
+fate-dnxuc-cb-rgb-float: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/cb_rgb_float.mxf
+fate-dnxuc-cb-yuv422-8: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/cb_yuv422_8.mxf
+fate-dnxuc-cb-yuv422-10: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/cb_yuv422_10.mxf
+fate-dnxuc-cb-yuv422-12: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/cb_yuv422_12.mxf
+
+fate-dnxuc-ramp-rgb-8: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/ramp_rgb_8.mxf
+fate-dnxuc-ramp-rgb-10: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/ramp_rgb_10.mxf
+fate-dnxuc-ramp-rgb-12: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/ramp_rgb_12.mxf
+fate-dnxuc-ramp-rgb-half: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/ramp_rgb_half.mxf
+fate-dnxuc-ramp-rgb-float: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/ramp_rgb_float.mxf
+fate-dnxuc-ramp-yuv422-8: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/ramp_yuv422_8.mxf
+fate-dnxuc-ramp-yuv422-10: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/ramp_yuv422_10.mxf
+fate-dnxuc-ramp-yuv422-12: CMD = framecrc -flags +bitexact -i $(TARGET_SAMPLES)/dnxuc/ramp_yuv422_12.mxf
diff --git a/tests/ref/fate/dnxuc-cb-rgb-10 b/tests/ref/fate/dnxuc-cb-rgb-10
new file mode 100644
index 0000000..398e0da
--- /dev/null
+++ b/tests/ref/fate/dnxuc-cb-rgb-10
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   786432, 0x2e402ec2
+0,          1,          1,        1,   786432, 0x2e402ec2
+0,          2,          2,        1,   786432, 0x2e402ec2
diff --git a/tests/ref/fate/dnxuc-cb-rgb-12 b/tests/ref/fate/dnxuc-cb-rgb-12
new file mode 100644
index 0000000..4e3235f
--- /dev/null
+++ b/tests/ref/fate/dnxuc-cb-rgb-12
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   786432, 0x6fb11356
+0,          1,          1,        1,   786432, 0x6fb11356
+0,          2,          2,        1,   786432, 0x6fb11356
diff --git a/tests/ref/fate/dnxuc-cb-rgb-8 b/tests/ref/fate/dnxuc-cb-rgb-8
new file mode 100644
index 0000000..189babc
--- /dev/null
+++ b/tests/ref/fate/dnxuc-cb-rgb-8
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   393216, 0xc1f6a4cc
+0,          1,          1,        1,   393216, 0xc1f6a4cc
+0,          2,          2,        1,   393216, 0xc1f6a4cc
diff --git a/tests/ref/fate/dnxuc-cb-rgb-float b/tests/ref/fate/dnxuc-cb-rgb-float
new file mode 100644
index 0000000..f6571ba
--- /dev/null
+++ b/tests/ref/fate/dnxuc-cb-rgb-float
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,  1572864, 0x535c1923
+0,          1,          1,        1,  1572864, 0x535c1923
+0,          2,          2,        1,  1572864, 0x535c1923
diff --git a/tests/ref/fate/dnxuc-cb-rgb-half b/tests/ref/fate/dnxuc-cb-rgb-half
new file mode 100644
index 0000000..838b84b
--- /dev/null
+++ b/tests/ref/fate/dnxuc-cb-rgb-half
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   786432, 0xec588a41
+0,          1,          1,        1,   786432, 0xec588a41
+0,          2,          2,        1,   786432, 0xec588a41
diff --git a/tests/ref/fate/dnxuc-cb-yuv422-10 b/tests/ref/fate/dnxuc-cb-yuv422-10
new file mode 100644
index 0000000..6e7c537
--- /dev/null
+++ b/tests/ref/fate/dnxuc-cb-yuv422-10
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   524288, 0xad829843
+0,          1,          1,        1,   524288, 0xad829843
+0,          2,          2,        1,   524288, 0xad829843
diff --git a/tests/ref/fate/dnxuc-cb-yuv422-12 b/tests/ref/fate/dnxuc-cb-yuv422-12
new file mode 100644
index 0000000..01e5976
--- /dev/null
+++ b/tests/ref/fate/dnxuc-cb-yuv422-12
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   524288, 0x70277284
+0,          1,          1,        1,   524288, 0x70277284
+0,          2,          2,        1,   524288, 0x70277284
diff --git a/tests/ref/fate/dnxuc-cb-yuv422-8 b/tests/ref/fate/dnxuc-cb-yuv422-8
new file mode 100644
index 0000000..1e4bb3e
--- /dev/null
+++ b/tests/ref/fate/dnxuc-cb-yuv422-8
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   262144, 0x12299f3f
+0,          1,          1,        1,   262144, 0x12299f3f
+0,          2,          2,        1,   262144, 0x12299f3f
diff --git a/tests/ref/fate/dnxuc-ramp-rgb-10 b/tests/ref/fate/dnxuc-ramp-rgb-10
new file mode 100644
index 0000000..99a2eb9
--- /dev/null
+++ b/tests/ref/fate/dnxuc-ramp-rgb-10
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   786432, 0xe4d06700
+0,          1,          1,        1,   786432, 0xe4d06700
+0,          2,          2,        1,   786432, 0xe4d06700
diff --git a/tests/ref/fate/dnxuc-ramp-rgb-12 b/tests/ref/fate/dnxuc-ramp-rgb-12
new file mode 100644
index 0000000..19eb687
--- /dev/null
+++ b/tests/ref/fate/dnxuc-ramp-rgb-12
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   786432, 0xb8c802a4
+0,          1,          1,        1,   786432, 0xb8c802a4
+0,          2,          2,        1,   786432, 0xb8c802a4
diff --git a/tests/ref/fate/dnxuc-ramp-rgb-8 b/tests/ref/fate/dnxuc-ramp-rgb-8
new file mode 100644
index 0000000..2c1caae
--- /dev/null
+++ b/tests/ref/fate/dnxuc-ramp-rgb-8
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   393216, 0xd1f001f2
+0,          1,          1,        1,   393216, 0xd1f001f2
+0,          2,          2,        1,   393216, 0xd1f001f2
diff --git a/tests/ref/fate/dnxuc-ramp-rgb-float b/tests/ref/fate/dnxuc-ramp-rgb-float
new file mode 100644
index 0000000..1a929fa
--- /dev/null
+++ b/tests/ref/fate/dnxuc-ramp-rgb-float
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,  1572864, 0xfebf5914
+0,          1,          1,        1,  1572864, 0xfebf5914
+0,          2,          2,        1,  1572864, 0xfebf5914
diff --git a/tests/ref/fate/dnxuc-ramp-rgb-half b/tests/ref/fate/dnxuc-ramp-rgb-half
new file mode 100644
index 0000000..93d39c7
--- /dev/null
+++ b/tests/ref/fate/dnxuc-ramp-rgb-half
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   786432, 0x6b0900ff
+0,          1,          1,        1,   786432, 0x6b0900ff
+0,          2,          2,        1,   786432, 0x6b0900ff
diff --git a/tests/ref/fate/dnxuc-ramp-yuv422-10 b/tests/ref/fate/dnxuc-ramp-yuv422-10
new file mode 100644
index 0000000..ef158a5
--- /dev/null
+++ b/tests/ref/fate/dnxuc-ramp-yuv422-10
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   524288, 0xb86e482d
+0,          1,          1,        1,   524288, 0xb86e482d
+0,          2,          2,        1,   524288, 0xb86e482d
diff --git a/tests/ref/fate/dnxuc-ramp-yuv422-12 b/tests/ref/fate/dnxuc-ramp-yuv422-12
new file mode 100644
index 0000000..4596dc8
--- /dev/null
+++ b/tests/ref/fate/dnxuc-ramp-yuv422-12
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   524288, 0x9bbd5677
+0,          1,          1,        1,   524288, 0x9bbd5677
+0,          2,          2,        1,   524288, 0x9bbd5677
diff --git a/tests/ref/fate/dnxuc-ramp-yuv422-8 b/tests/ref/fate/dnxuc-ramp-yuv422-8
new file mode 100644
index 0000000..bb6fd38
--- /dev/null
+++ b/tests/ref/fate/dnxuc-ramp-yuv422-8
@@ -0,0 +1,8 @@
+#tb 0: 1/24
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 512x256
+#sar 0: 1/1
+0,          0,          0,        1,   262144, 0x386e0fa6
+0,          1,          1,        1,   262144, 0x386e0fa6
+0,          2,          2,        1,   262144, 0x386e0fa6